﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ScheduleViewWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<Appointment> appointments;
        private Appointment app;
        private Appointment app2;
        public MainWindow()
        {
            InitializeComponent();
            this.app = new Appointment { Subject = "App1", Start = new DateTime(2013, 11, 25, 5, 0, 0), End = new DateTime(2013, 11, 25, 10, 0, 0) };
            this.app2 = new Appointment { Subject = "App2", Start = new DateTime(2013, 11, 25, 15, 0, 0), End = new DateTime(2013, 11, 25, 16, 0, 0) };
            this.appointments = new ObservableCollection<Appointment>
            {
               this.app, this.app2
            };

            this.ScheduleView.AppointmentsSource = this.appointments;          
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.ScrollToAppointment(this.app);            
        }
        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.ScrollToAppointment(this.app2);
        }

        private void ScrollToAppointment(Appointment appointment)
        {
            if (appointment.Start.Hour < this.ScheduleView.ActiveViewDefinition.DayStartTime.Hours)
            {
                var differenceInHours = this.ScheduleView.ActiveViewDefinition.DayStartTime.Hours - appointment.Start.Hour;
                var slot = new Slot { Start = appointment.Start.AddHours(differenceInHours), End = appointment.End };
                this.ScheduleView.SpecialSlotsSource = new ObservableCollection<Slot> { slot };

                this.ScheduleView.ScrollIntoView(slot);
            }
            else
            {
                this.ScheduleView.ScrollIntoView(appointment);
            }
        }
    }
}